#include <algorithm>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <vector>
using namespace std;

int N, M, D, U, V;
string R;
vector<string> F;
vector< vector<int> > G;

typedef pair<int,int> par;
const par foo(-1,-1);

#define PROCESS(r,f,nd,parent) { \
    pair<int,int> key((r),(f)); \
    if (!dist.count(key) || dist[key]>(nd)) { \
        Q.erase( make_pair(dist[key],key) ); \
        dist[key] = (nd); \
        if (parent!=foo) from[key] = (parent); \
        Q.insert( make_pair((nd),key) ); \
    } \
}

vector<par> get_moves(const par &kde) { // vstup: (index v R, zacinajuci fragment), vystup: zoznam dvojic (index v R, pocet chyb)
    int w = kde.second;
    map<par,par> from;
    par start(kde.first,0);
    map<par,int> dist;       dist[start] = 0;
    set< pair<int,par> > Q;  Q.insert( make_pair(0,start) );
    while (!Q.empty()) {
        int d = Q.begin()->first;
        if (d > D) break;
        unsigned roff,foff; tie(roff,foff) = Q.begin()->second;
        Q.erase( Q.begin() );
        if (roff<R.size() && foff<F[w].size() && R[roff]==F[w][foff]) PROCESS(roff+1,foff+1,d,foo);
        if (roff<R.size() && foff<F[w].size()) PROCESS(roff+1,foff+1,d+1,foo);
        if (roff<R.size()) PROCESS(roff+1,foff,d+1,foo);
        if (foff<F[w].size()) PROCESS(roff,foff+1,d+1,foo);
    }
    vector<par> answer;
    for (auto tmp:dist) if (tmp.second<=D && tmp.first.second == (int)F[w].size()) answer.push_back( par( tmp.first.first, tmp.second ) );
    return answer;
}

void load() {
    cin >> N >> M;
    F.resize(N); for (string &x:F) cin >> x;
    G.resize(N+1);
    while (M--) { int a,b; cin >> a >> b; G[a-1].push_back(b-1); }
    cin >> D >> U >> V >> R; --U; --V;
    G[V].push_back(N);
}

int main() {
    load();
    map<par,par> from;
    map<par,int> dist;       dist[ par(0,U) ] = 0;
    set< pair<int,par> > Q;  Q.insert( make_pair(0,par(0,U)) );
    while (!Q.empty()) {
        int d = Q.begin()->first;
        if (d > D) break;
        int off,w; tie(off,w) = Q.begin()->second;
        Q.erase( Q.begin() );
        if (w==N) continue;
        for (par m:get_moves(par(off,w))) for (int x:G[w]) PROCESS(m.first,x,d+m.second,par(off,w));
    }
    par kde(R.size(),N);
    if (!dist.count(kde) || dist[kde]>D) { cout << "-1\n"; return 0; }
    vector<int> answer;
    while (from.count(kde)) { kde=from[kde]; answer.push_back(kde.second); }
    reverse(answer.begin(),answer.end());
    for (unsigned i=0; i<answer.size(); ++i) cout << (answer[i]+1) << (i+1==answer.size()?"\n":" ");
}
